// DateIntervalBasicTest.h  Datumsintervall-Berechner-Basis-Tests
//
// (c) 2003, oose.de GmbH
//////////////////////////////////////////////////////////////////////////

#ifndef DATE_INTERVAL_BASIC_TESTS_H
#define DATE_INTERVAL_BASIC_TESTS_H

#include <cppunit/extensions/HelperMacros.h>
#include "DateInterval.h"


class DateIntervalBasicTest : public CppUnit::TestFixture{
	CPPUNIT_TEST_SUITE(DateIntervalBasicTest);
	CPPUNIT_TEST(testValidDate);
	CPPUNIT_TEST(testInvalidDate);
	CPPUNIT_TEST(testResetDate);
	CPPUNIT_TEST_SUITE_END();

private:
	DateInterval* aDateInterval;

public:
//protected:
	void setUp(){
		aDateInterval = new DateInterval();
	}

	void tearDown(){
		delete aDateInterval;
	}

public:
	void testValidDate(){
		CPPUNIT_ASSERT(1 == aDateInterval->getDay());
		CPPUNIT_ASSERT(1 == aDateInterval->getMonth());
		CPPUNIT_ASSERT(1800 == aDateInterval->getYear());
		CPPUNIT_ASSERT(true == aDateInterval->reset(7,10,1961));
		CPPUNIT_ASSERT(7 == aDateInterval->getDay());
		CPPUNIT_ASSERT(10 == aDateInterval->getMonth());
		CPPUNIT_ASSERT(1961 == aDateInterval->getYear());
	}

	void testInvalidDate(){
		CPPUNIT_ASSERT(1 == aDateInterval->getDay());
		CPPUNIT_ASSERT(1 == aDateInterval->getMonth());
		CPPUNIT_ASSERT(1800 == aDateInterval->getYear());
		CPPUNIT_ASSERT(false == aDateInterval->reset(29,2,1961));
		CPPUNIT_ASSERT(1 == aDateInterval->getDay());
		CPPUNIT_ASSERT(1 == aDateInterval->getMonth());
		CPPUNIT_ASSERT(1800 == aDateInterval->getYear());
	}

	void testResetDate(){
		CPPUNIT_ASSERT(1 == aDateInterval->getDay());
		CPPUNIT_ASSERT(1 == aDateInterval->getMonth());
		CPPUNIT_ASSERT(1800 == aDateInterval->getYear());
		CPPUNIT_ASSERT(true == aDateInterval->reset(1,1,1800));
		CPPUNIT_ASSERT(true == aDateInterval->reset(31,12,2100));
		CPPUNIT_ASSERT(true == aDateInterval->reset(29,2,2000));

		CPPUNIT_ASSERT(false == aDateInterval->reset(31,12,1799));
		CPPUNIT_ASSERT(false == aDateInterval->reset(1,1,2101));
		CPPUNIT_ASSERT(false == aDateInterval->reset(12,0,2000));
		CPPUNIT_ASSERT(false == aDateInterval->reset(12,13,2000));
		CPPUNIT_ASSERT(false == aDateInterval->reset(0,7,1999));
		CPPUNIT_ASSERT(false == aDateInterval->reset(32,1,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(29,2,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(32,3,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(31,4,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(32,5,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(31,6,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(32,7,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(32,8,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(31,9,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(32,10,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(31,11,2001));
		CPPUNIT_ASSERT(false == aDateInterval->reset(32,12,2001));
		CPPUNIT_ASSERT(29 == aDateInterval->getDay());
		CPPUNIT_ASSERT(2 == aDateInterval->getMonth());
		CPPUNIT_ASSERT(2000 == aDateInterval->getYear());
	}
};

#endif